import "package:flutter/material.dart";

class IconStyle {
  final Color? color;
  final String? semanticLabel;
  final double? size;
  final TextDirection? textDirection;
  final Key? key;

  IconStyle({
    this.color,
    this.semanticLabel,
    this.size,
    this.textDirection,
    this.key,
  });
}

Icon _addIconStyle(IconData icon, IconStyle? iconStyle) => Icon(
      icon,
      color: iconStyle?.color,
      semanticLabel: iconStyle?.semanticLabel,
      size: iconStyle?.size,
      textDirection: iconStyle?.textDirection,
      key: iconStyle?.key,
    );

class ThemedIcons {
  const ThemedIcons._();

  /// <i class="material-icons md-36">delete</i> &#x2014; material icon named "delete".
  static Icon delete({IconStyle? iconStyle}) => _addIconStyle(
        Icons.delete,
        iconStyle,
      );
  static Icon lock({IconStyle? iconStyle}) => _addIconStyle(
        Icons.lock,
        iconStyle,
      );
  static Icon support({IconStyle? iconStyle}) => _addIconStyle(
        Icons.support_agent,
        iconStyle,
      );

  static Icon calls({IconStyle? iconStyle}) => _addIconStyle(
        Icons.phone,
        iconStyle,
      );

  static Icon archive({IconStyle? iconStyle}) => _addIconStyle(
        Icons.archive,
        iconStyle,
      );
  static Icon checklist({IconStyle? iconStyle}) => _addIconStyle(
        Icons.checklist_rounded,
        iconStyle,
      );

  static Icon clock({IconStyle? iconStyle}) => _addIconStyle(
        Icons.access_time,
        iconStyle,
      );

  static Icon share({IconStyle? iconStyle}) =>
      _addIconStyle(Icons.share, iconStyle);

  static Icon logout({IconStyle? iconStyle}) =>
      _addIconStyle(Icons.logout, iconStyle);

  static Icon sheet({IconStyle? iconStyle}) =>
      _addIconStyle(Icons.view_comfortable_rounded, iconStyle);

  static Icon time({IconStyle? iconStyle}) =>
      _addIconStyle(Icons.access_time_filled, iconStyle);

  static Icon smartphone({IconStyle? iconStyle}) =>
      _addIconStyle(Icons.smartphone, iconStyle);

  static Icon edit({IconStyle? iconStyle}) =>
      _addIconStyle(Icons.edit, iconStyle);

  static Icon pin({IconStyle? iconStyle}) =>
      _addIconStyle(Icons.pin_drop_outlined, iconStyle);

  static Icon pencil({IconStyle? iconStyle}) =>
      _addIconStyle(Icons.border_color, iconStyle);

  static Icon refresh({IconStyle? iconStyle}) =>
      _addIconStyle(Icons.refresh, iconStyle);

  static Icon minus1({IconStyle? iconStyle}) =>
      _addIconStyle(Icons.exposure_minus_1, iconStyle);

  static Icon plu1({IconStyle? iconStyle}) =>
      _addIconStyle(Icons.exposure_plus_1, iconStyle);

  static Icon wallet({IconStyle? iconStyle}) =>
      _addIconStyle(Icons.account_balance_wallet_outlined, iconStyle);
  static Icon send({IconStyle? iconStyle}) =>
      _addIconStyle(Icons.send, iconStyle);

  static Icon cloudUpload({IconStyle? iconStyle}) =>
      _addIconStyle(Icons.cloud_upload_outlined, iconStyle);

  static Icon calendar({IconStyle? iconStyle}) =>
      _addIconStyle(Icons.calendar_today, iconStyle);
  static Icon settings({IconStyle? iconStyle}) =>
      _addIconStyle(Icons.settings, iconStyle);

  static Icon person({IconStyle? iconStyle}) =>
      _addIconStyle(Icons.person, iconStyle);

  static Icon notification({IconStyle? iconStyle}) =>
      _addIconStyle(Icons.notification_add, iconStyle);

  static Icon chat({IconStyle? iconStyle}) =>
      _addIconStyle(Icons.chat, iconStyle);

  static Icon folder({IconStyle? iconStyle}) =>
      _addIconStyle(Icons.folder_open, iconStyle);

  static Icon personSearch({IconStyle? iconStyle}) =>
      _addIconStyle(Icons.person_search_outlined, iconStyle);

  static Icon files({IconStyle? iconStyle}) =>
      _addIconStyle(Icons.file_copy, iconStyle);

  static Icon bus({IconStyle? iconStyle}) =>
      _addIconStyle(Icons.bus_alert_outlined, iconStyle);

  static Icon receipt({IconStyle? iconStyle}) =>
      _addIconStyle(Icons.receipt_long, iconStyle);

  static Icon suitcase({IconStyle? iconStyle}) =>
      _addIconStyle(Icons.shopping_bag_outlined, iconStyle);

  static Icon cartCheckout({IconStyle? iconStyle}) =>
      _addIconStyle(Icons.shopping_cart_checkout, iconStyle);

  static Icon building({IconStyle? iconStyle}) =>
      _addIconStyle(Icons.maps_home_work_outlined, iconStyle);

  static Icon peploe({IconStyle? iconStyle}) =>
      _addIconStyle(Icons.group, iconStyle);

  static Icon home({IconStyle? iconStyle}) =>
      _addIconStyle(Icons.home_filled, iconStyle);

  static Icon followUp({IconStyle? iconStyle}) =>
      _addIconStyle(Icons.follow_the_signs, iconStyle);

  static Icon dollarSign({IconStyle? iconStyle}) =>
      _addIconStyle(Icons.monetization_on, iconStyle);

  static Icon delivery({IconStyle? iconStyle}) =>
      _addIconStyle(Icons.delivery_dining, iconStyle);

  static Icon boxesStackPlus({IconStyle? iconStyle}) =>
      _addIconStyle(Icons.dashboard_customize, iconStyle);

  static Icon boxesStackPlusEmpty({IconStyle? iconStyle}) =>
      _addIconStyle(Icons.dashboard_customize_outlined, iconStyle);

  static Icon bookmark({IconStyle? iconStyle}) =>
      _addIconStyle(Icons.bookmark, iconStyle);

  static Icon arrowUp({IconStyle? iconStyle}) =>
      _addIconStyle(Icons.keyboard_arrow_up, iconStyle);

  static Icon arrowDown({IconStyle? iconStyle}) =>
      _addIconStyle(Icons.keyboard_arrow_down, iconStyle);

  static Icon zoomIn({IconStyle? iconStyle}) =>
      _addIconStyle(Icons.zoom_in, iconStyle);

  static Icon zoomOut({IconStyle? iconStyle}) =>
      _addIconStyle(Icons.zoom_out, iconStyle);

  static Icon fileUnknow({IconStyle? iconStyle}) =>
      _addIconStyle(Icons.error_outline, iconStyle);

  static Icon arrowBack({IconStyle? iconStyle}) =>
      _addIconStyle(Icons.arrow_back_ios_new, iconStyle);

  static Icon arrowForwared({IconStyle? iconStyle}) =>
      _addIconStyle(Icons.arrow_forward_ios, iconStyle);

  static Icon moreHoriz({IconStyle? iconStyle}) =>
      _addIconStyle(Icons.more_horiz, iconStyle);

  static Icon filter({IconStyle? iconStyle}) =>
      _addIconStyle(Icons.filter_alt, iconStyle);

  static Icon pdfFile({IconStyle? iconStyle}) =>
      _addIconStyle(Icons.picture_as_pdf, iconStyle);

  static Icon copy({IconStyle? iconStyle}) =>
      _addIconStyle(Icons.copy, iconStyle);

  static Icon video({IconStyle? iconStyle}) =>
      _addIconStyle(Icons.ondemand_video, iconStyle);

  static Icon check({IconStyle? iconStyle}) =>
      _addIconStyle(Icons.check, iconStyle);

  static Icon search({IconStyle? iconStyle}) =>
      _addIconStyle(Icons.search, iconStyle);

  static Icon clear({IconStyle? iconStyle}) =>
      _addIconStyle(Icons.clear, iconStyle);

  static Icon add({IconStyle? iconStyle}) =>
      _addIconStyle(Icons.add, iconStyle);
}
